' MonthlyRecentSize.VBS V1.04 (C) yoshioka.teruo@nifty.com 2005-08-22
' MonthlyRecentSize.VBS shows monthly size of recent document folder.
' Usage: Start MonthlyRecentSize.VBS
' Usage: CScript //NoLogo MonthlyRecentSize.VBS >stdout

Option Explicit
Dim wShell
Dim fso
Dim dic
Dim Folder
Dim File
Dim DateLastModified
Dim MonthLastModified
Dim key
Dim Items
Dim Rows
Dim SC
Dim JS
Dim Folders
Dim Files
Dim Size

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")
Set dic=CreateObject("Scripting.Dictionary")

Set Folder=fso.GetFolder(wShell.SpecialFolders("Recent"))
For Each File In Folder.SubFolders
  DateLastModified=File.DateLastModified
  MonthLastModified=Year(DateLastModified)*100+Month(DateLastModified)
  If dic.Exists(MonthLastModified) Then
    Items=dic.Item(MonthLastModified)
    Items(0)=Items(0)+1
    Items(2)=Items(2)+File.Size
    dic.Item(MonthLastModified)=Items
  Else
    dic.Add MonthLastModified,Array(1,0,File.Size)
  End If
Next
For Each File In Folder.Files
  DateLastModified=File.DateLastModified
  MonthLastModified=Year(DateLastModified)*100+Month(DateLastModified)
  If dic.Exists(MonthLastModified) Then
    Items=dic.Item(MonthLastModified)
    Items(1)=Items(1)+1
    Items(2)=Items(2)+File.Size
    dic.Item(MonthLastModified)=Items
  Else
    dic.Add MonthLastModified,Array(0,1,File.Size)
  End If
Next
Rows=Array("Year/"&vbTab&"Folders"&vbTab&"Files"&vbTab&"Size Bytes")
Set SC=CreateObject("ScriptControl") 
SC.Language="JScript" 
Call SC.AddObject("dic",dic) 
Set JS=SC.Eval("new VBArray(dic.Keys()).toArray()") 
For Each key In JS.sort() 
  ReDim Preserve Rows(UBound(Rows)+1)
  Rows(UBound(Rows))=Join(Array(Left(key,4)&"/"&Right(key,2),_
    FormatNumber(dic.Item(key)(0),0),_
    FormatNumber(dic.Item(key)(1),0),_
    FormatNumber(dic.Item(key)(2),0)),vbTab)
  Folders=Folders+dic.Item(key)(0)
  Files=Files+dic.Item(key)(1)
  Size=Size+dic.Item(key)(2)
Next
ReDim Preserve Rows(UBound(Rows)+1)
Rows(UBound(Rows))=Join(Array("  v",_
    FormatNumber(Folders,0),_
    FormatNumber(Files,0),_
    FormatNumber(Size,0)),vbTab)
WScript.Echo Join(Rows,vbLf)
WScript.Quit
