' ObsoleteRecentClear.VBS V1.03 (C) yoshioka.teruo@nifty.com 2005-04-22
' ObsoleteRecentClear.VBS clears obsolete recent document folder.
' Usage: Start ObsoleteRecentClear.VBS [n{d|m}]

Option Explicit
Dim wShell
Dim fso
Dim Folder
Dim File
Dim Folders
Dim Files
Dim Sum
Dim Today:Today=Now
Dim Unit
Dim Diff
Dim arg

arg=""

If WScript.Arguments.Count=1 Then
  arg=WScript.Arguments(0)
End If
If arg="" Then
  arg=InputBox("Enter time span in nn{d|m}",WScript.ScriptName,"3m")
End If
If IsEmpty(arg) Then WScript.Quit
Unit=LCase(Right(arg,1))
If Unit<>"d" And Unit<>"m" Then
  WScript.Echo "Invalid Unit - " & Unit
  WScript.Quit
End If
Diff=Left(arg,Len(arg)-1)
If Not IsNumeric(Diff) Then
  WScript.Echo "Invalid Number - " & Diff
  WScript.Quit
End If
Diff=CLng(Diff)

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

Set Folder=fso.GetFolder(wShell.SpecialFolders("Recent"))
For Each File In Folder.SubFolders
  If DateDiff(Unit,File.DateLastModified,Today)>=Diff Then
    Folders=Folders+1
    Sum=Sum+File.Size
  End If
Next
For Each File In Folder.Files
  If DateDiff(Unit,File.DateLastModified,Today)>=Diff Then
    Files=Files+1
    Sum=Sum+File.Size
  End If
Next

If MsgBox("Before"&vbTab&arg&vbLf&_
          "Folders"&vbTab&FormatNumber(Folders,0)&vbLf&_
          "Files"&vbTab&FormatNumber(Files,0)&vbLf&_
          "Bytes"&vbTab&FormatNumber(Sum,0),_
          vbOkCancel+vbDefaultButton2,_
          "Clear Recent Document Folder ?")<>vbOk Then
  WScript.Quit
End If
For Each File In Folder.SubFolders
  If DateDiff(Unit,File.DateLastModified,Today)>=Diff Then
    Folders=Folder-1
    Sum=Sum-File.Size
    File.Delete True
  End If
Next
For Each File In Folder.Files
  If DateDiff(Unit,File.DateLastModified,Today)>=Diff Then
    Files=Files-1
    Sum=Sum-File.Size
    File.Delete
  End If
Next
If Folders<>0 Or Files<>0 Or Sum<>0 Then
  WScript.Echo "Error",Folders,Files,Sum
End If
WScript.Quit
