' ObsoleteRecentSize.VBS V1.03 (C) yoshioka.teruo@nifty.com 2005-04-22
' ObsoleteRecentSize.VBS shows obsolete size of recent document folder.
' Usage: Start ObsoleteRecentSize.VBS [n{d|m}]
' Usage: CScript //NoLogo ObsoleteRecentSize.VBS [n{d|m}] >stdout

Option Explicit
Dim wShell
Dim fso
Dim Folder
Dim File
Dim Folders
Dim Files
Dim Sum
Dim Today:Today=Now
Dim Unit
Dim Diff
Dim arg

arg=""

If WScript.Arguments.Count=1 Then
  arg=WScript.Arguments(0)
End If
If arg="" Then
  arg=InputBox("Enter time span in nn{d|m}",WScript.ScriptName,"3m")
End If
If IsEmpty(arg) Then WScript.Quit
Unit=LCase(Right(arg,1))
If Unit<>"d" And Unit<>"m" Then
  WScript.Echo "Invalid Unit - " & Unit
  WScript.Quit
End If
Diff=Left(arg,Len(arg)-1)
If Not IsNumeric(Diff) Then
  WScript.Echo "Invalid Number - " & Diff
  WScript.Quit
End If
Diff=CLng(Diff)

Set wShell=CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

Set Folder=fso.GetFolder(wShell.SpecialFolders("Recent"))
For Each File In Folder.SubFolders
  If DateDiff(Unit,File.DateLastModified,Today)>=Diff Then
    Folders=Folders+1
    Sum=Sum+File.Size
  End If
Next
For Each File In Folder.Files
  If DateDiff(Unit,File.DateLastModified,Today)>=Diff Then
    Files=Files+1
    Sum=Sum+File.Size
  End If
Next

WScript.Echo "Before"&vbTab&arg&vbLf&_
  "Folders"&vbTab&FormatNumber(Folders,0)&vbLf&_
  "Files"&vbTab&FormatNumber(Files,0)&vbLf&_
  "Bytes"&vbTab&FormatNumber(Sum,0)
WScript.Quit
